package counter1;

// Klasa Counter

import java.beans.*;
import java.io.*;

public class Counter implements Serializable {

  private int count = 0;    // waciwo count

  // Pomocniczy obiekt do prowadzenia listy suchaczy zmian waciwoci oraz
  // propagowania zmian  wrd zarejestrowanych zuchaczy
   private PropertyChangeSupport propertyChange = new PropertyChangeSupport(this);


  // Konstruktory

  public Counter() {
    this(0);
  }

  public Counter(int aCount) {
    setCount( aCount );
  }


  // Metody przyczania i odczania suchaczy zmian waciwoci

  public synchronized void addPropertyChangeListener(PropertyChangeListener listener) {
    propertyChange.addPropertyChangeListener(listener);
  }

  public synchronized void removePropertyChangeListener(PropertyChangeListener l) {
    propertyChange.removePropertyChangeListener(l);
  }

  // Proste metody zwikszania i zmniejszania licznika

  public void increment() {
    setCount(getCount()+1);
  }

  public void decrement() {
    setCount(getCount()-1);
  }


  // Getter waciwoci "count"
  public int getCount() {
    return count;
  }

  // Setter waciowci "count"
  public synchronized void setCount(int aCount) {
    int oldValue = count;
    count = aCount;

    // wywoanie metody firePropertChange z klasy PropertyChangeSupport
    // powoduje wygenerowanie zdarzenia PropertyChangeEvent i rozpropagowanie
    // go wrd wszystkich przyczonych suchaczy, ale tylko wtedy, gdy nowa
    // warto waciwoci rni si od starej wartoci

    propertyChange.firePropertyChange("count", new Integer(oldValue),
                                            new Integer(aCount));
  }

}