import java.io.*;
import java.text.*;
import java.util.*;

public class Parse2 {

  public static void main(String[] args) {

    // Format walutowy w domylnej lokalizacji
    // czyli w PL np. 12 z
    NumberFormat format = NumberFormat.getCurrencyInstance();

    // Lista wartoci wydatkw (zapisanych w tekcie pliku)
    List numList = new ArrayList();

    try {
      BufferedReader br = new BufferedReader(
                            new FileReader(args[0])
                          );

      // czytanie kolejnych wierszu
      String in;
      while ((in = br.readLine()) != null) {

        int p = 0;                    // biecy indeks rozbioru
        int last  = in.length() - 1;  // ostatni indeks w wierszu

        // Utworzenie pozycji rozbioru wiersza (od 0)
        ParsePosition ppos = new ParsePosition(0);

        // Dopki nie dobieglimy do koca wiersza
        while (p <= last) {
           // Prbujemy pobra kolejn liczb w formacie walutowym
           Number num = format.parse(in, ppos);

           if (num == null)              // jeeli bd,
             p = ppos.getErrorIndex()+1; // indeks na znaku po bdzie
           else {                        // jeeli udao si sczyta warto
             p =  ppos.getIndex();   // indeks na nastpnym znaku po formacie
             if (!Character.isLetter(in.charAt(p))) // jeeli to nie litera
                numList.add(num);           // dodajemy warto do listy
           }
           ppos.setIndex(p);         // ustawiamy nastpn pozycj
        }                            // od ktrej kontynuacja rozbioru
      }
      br.close();
    } catch(Exception exc) {
        exc.printStackTrace();
        System.exit(1);
    }

    // Wypisanie i podsumowanie zapisanych w pliku wydatkw
    System.out.println("Wydatki w z:");
    double suma = 0;
    for (Iterator iter = numList.iterator(); iter.hasNext(); ) {
      Number val  = (Number) iter.next();
      System.out.println(val);
      suma += val.doubleValue();
    }
    System.out.println("Wydano w sumie: " + format.format(suma));
  }
}