import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.nio.charset.*;


// SERWLET POBIERANIA PARAMETRW

public class GetParamsServ extends HttpServlet {

  private ServletContext context;
  private String resBundleServ;    // nazwa serwletu przygotowujcego
                                   // sparmetryzowan informacje


  // Inicjacja
  public void init() {
    context = getServletContext();
    resBundleServ = context.getInitParameter("resBundleServ");
  }

  // Obsuga zlece
  public void serviceRequest(HttpServletRequest req,
                             HttpServletResponse resp)
                             throws ServletException, IOException
  {


    // Wczenie serwletu przygotowujcego informacje z z zasobw
    // (ResourceBundle). Informacja bdzie dostpna poprzez
    // statyczne metody klasy BundleInfo

    RequestDispatcher disp = context.getRequestDispatcher(resBundleServ);
    disp.include(req, resp);

    // Pobranie potrzebnej informacji
    // ktora zostaa wczesniej przygotowana
    // przez klas BundleInfo na podstawie zlokalizowanych zasobw

    // Zlokalizowana strona kodowa
    String charset = BundleInfo.getCharset();

    // Napisy nagwkowe
    String[] headers = BundleInfo.getHeaders();

    // Nazwy parametrw (pojawi si w formularzu,
    // ale rwnie s to nazwy parametrw dla Command)
    String[] pnames = BundleInfo.getCommandParamNames();

    // Opisy parametrw - aby byo wiadomo co w formularzu wpisywa
    String[] pdes   = BundleInfo.getCommandParamDescr();

    // Napis na przycisku
    String submitMsg = BundleInfo.getSubmitMsg();

    // Ew. kocowe napisy na stronie
    String[] footers = BundleInfo.getFooters();

    // Ustalenie waciwego kodowania zlecenia
    // - bez tego nie bdzie mona wasciwie odczyta parametrw
    req.setCharacterEncoding(charset);

    // Pobranie aktualnej sesji
    // w jej atrybutach s/bd przechowywane
    // wartoci parametrw

    HttpSession session = req.getSession();

    // Generowanie strony

    resp.setCharacterEncoding(charset);
    PrintWriter out = resp.getWriter();

    out.println("<center><h2>");
    for (int i=0; i<headers.length; i++)
       out.println(headers[i]);
    out.println("</center></h2><hr>");

       // formularz
    out.println("<form method=\"post\">");
    for (int i=0; i<pnames.length; i++) {
     out.println(pdes[i] + "<br>");
     out.print("<input type=\"text\" size=\"70\" name=\"" +
                   pnames[i] +  "\"");

       // Jezeli s ju wartoci parametrw - pokaemy je w formularzu
      String pval = (String) session.getAttribute("param_"+pnames[i]);
      if (pval != null) out.print(" value=\"" + pval + "\"");
      out.println("><br>");
    }
    out.println("<br><input type=\"submit\" value=\"" + submitMsg + "\">");
    out.println("</form>");

    // Pobieranie parametrw z formularza

    for (int i=0; i<pnames.length; i++) {
      String paramVal = req.getParameter(pnames[i]);
         // Jeeli brak parametru (w) - konczymy
      if (paramVal == null) return;

      // Jest parametr - zapiszmy jego warto jako atrybut sesji.
      // Zostanie on pobrany przez Controller
      // ktry ustali te wartoci dla wykonania Command

      session.setAttribute("param_" + pnames[i], paramVal);

    }
  }


  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
                 throws ServletException, IOException
  {
      serviceRequest(request, response);
  }

  public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
                 throws ServletException, IOException
  {
      serviceRequest(request, response);
  }

}